import java.applet.Applet;
import java.awt.*;
import java.awt.image.*;
import java.lang.reflect.*;
import java.net.URL;

public class ImageApplet extends Applet implements ImageObserver {

    /** Target width of the image. */
    private int width = -1;

    /** Target height of the image. */
    private int height = -1;

    private int posx = 0;
    private int posy = 0;

    /** The image. */
    private Image image;

    private int scalingHint = Image.SCALE_DEFAULT;

    public void init() {

	// Get the parameters.
	try {
	    String tmp = null;
	    
	    // The scaling algorithm
	    tmp = getParameter("scalingHint");
	    if ( tmp != null ) {
		try {
		    this.scalingHint = ((Integer)(Class.forName("java.awt.Image").getField(tmp).get(null))).intValue();
		} catch ( Exception e ) {
		    this. scalingHint = Image.SCALE_DEFAULT;
		}
	    }

	    // The image
	    tmp = getParameter("image");
	    if ( tmp != null ) {
		this.image = getImage( new URL( tmp ) );
		this.width = this.image.getWidth( this );
		this.height = this.image.getHeight( this );
	    }
	} catch ( Exception e ) {
	}
	
    }

    public boolean imageUpdate( Image img, int infoflags, int x, int y, int width, int height ) {
	this.width = width;
	this.height = height;

	if ( this.width > 0 && this.height > 0 ) {
	    resizeImage();
	    return false;
	}
	else return true;
    }

    private void resizeImage() {
	if ( this.image != null ) {
	    /*
	     * Resize the image
	     */

	    /*
	    int wdif = width - this.getWidth();
	    int hdif = width - this.getHeight();
	    if ( wdif > 0 || hdif > 0 ) {
		if ( wdif > hdif )
		    this.image = this.image.getScaledInstance( this.getWidth(), -1, this.scalingHint );
	 	else 
		    this.image = this.image.getScaledInstance( -1, this.getHeight(), this.scalingHint );

		this.width = this.image.getWidth( this );
		this.height = this.image.getHeight( this );
	    }
	    */
	    /*
	     * Set the position of the image.
	     */
	    /*
	    this.posx = (int)((this.getWidth()-width )/2);
	    this.posy = 0;
	    
	    if ( this.height < this.getHeight() ) {
		resize( this.getWidth(), this.height );
	    }
	    */
	}
    }
    
    public void paint( Graphics g ) {
	if ( this.image != null ) {
	    g.drawImage( this.image, posx, posy, null );
	}
	else {
	    g.drawString( "Image ("+getParameter("image")+") not found.", 20, 20 );
	}
    }
}
