package fi.helsinki.w3m.filter;
import fi.helsinki.w3m.metadata.item.Image;
import fi.helsinki.w3m.profile.Profile;

/*
 * $Author: jiemakel $
 * $Revision: 1.15 $
 * $Date: 2002/04/24 10:13:39 $
 */

/**
*This class extends the Image class of Metadata by encapsulating the Image together with it's utility.
*
*/

public class InterestingImage extends Image implements Comparable {

    private int utility;
    
    public InterestingImage(Image image) {
	super(image);
    }

    public boolean setUtility(int util) {
	utility=util;
	return true;
    }

    public int getUtility() {
	return utility;
    }

    public int calculateUtility(UtilityFunction uf, UtilityInformation ui) {
	setUtility(uf.getUtility(this,ui));
	return getUtility();
    }

    public int compareTo(Object o) {
	InterestingImage ii=(InterestingImage)o;
	return getUtility()-ii.getUtility();
    }
    
}
