package fi.helsinki.w3m.filter;
import fi.helsinki.w3m.profile.Profile;
import fi.helsinki.w3m.metadata.MuseumModel;
import fi.helsinki.w3m.metadata.item.Image;

/*
 * $Author: jiemakel $
 * $Revision: 1.13 $
 * $Date: 2002/05/08 09:01:12 $
 */

public class InterestingLinkGlobalAccessCountUtilityFunction extends UtilityFunction{
	private MuseumModel model;

	public InterestingLinkGlobalAccessCountUtilityFunction(MuseumModel model){
		this.model=model;
	
	}
/**
*This method calculates the division of accesscount to an Image of a given InterestingLink by the maximum number of 
*accesses in the model.
* 
*@param il This is received InterestingLink.
*@param profile This is the Profile of the caller. 
*@returns an integer mentioned above  
*/

	public int getUtility(InterestingLink il, Profile profile){
		long max=this.model.getImagePropertyWeightMaximum();
		Image image=il.getImage();
		long clicks=image.getWeight();
		int tmp=(int)(((clicks+1)<<MAXUTILITYSHIFT)/(max+1));
		log(il,tmp);
		return tmp;
	}

}
