package fi.helsinki.w3m.filter;
import fi.helsinki.w3m.profile.Profile;
import fi.helsinki.w3m.metadata.item.Image;
import fi.helsinki.w3m.metadata.ontology.ResourceProperty;
import java.util.Collection;
import java.util.Iterator;

/*
 * $Author: jiemakel $
 * $Revision: 1.21 $
 * $Date: 2002/05/08 09:01:12 $
 */

public class InterestingLinkImageLinkAccessCountUtilityFunction extends UtilityFunction {

/**
*This method searches the most accessed property of an image of InterestingLink and returns the division of 
*InterestingLinks propertys accessamount by number of accesses to the most accessed property which was searched. 
*@il This is the InterestingLink that is pruned in the method.
*@pl This is the Profile of the caller
*@returns an int that is a division of il's property accesscount by the amount of accesses to the most popular Property 
*/


    public int getUtility(InterestingLink il,UtilityInformation ui) {
        Collection imageProperties = ui.getSourceImage().getProperties();
        long maxPropertyAccessCount=0;
	for (Iterator i=imageProperties.iterator(); i.hasNext();) {
	    ResourceProperty ip=(ResourceProperty)i.next();
	    if (maxPropertyAccessCount<ip.getWeight()) maxPropertyAccessCount=ip.getWeight();
	}
	long linkMaxPropertyAccessCount=0;
	for (Iterator i=il.getProperties().iterator(); i.hasNext();) {
	    ResourceProperty ip=(ResourceProperty)i.next();
	    if (linkMaxPropertyAccessCount<ip.getWeight())linkMaxPropertyAccessCount=ip.getWeight();
	}
	int tmp=(int)(((linkMaxPropertyAccessCount+1) << MAXUTILITYSHIFT)/(maxPropertyAccessCount+1));
	log(il,tmp);
	return tmp;
    }

}
