package fi.helsinki.w3m.filter;
import fi.helsinki.w3m.profile.Profile;
import fi.helsinki.w3m.metadata.item.Image;
import fi.helsinki.w3m.metadata.ontology.*;
import fi.helsinki.w3m.metadata.*;
import java.util.Vector;
import java.util.Iterator;

/*
 * $Author: jiemakel $
 * $Revision: 1.18 $
 * $Date: 2002/05/08 09:01:12 $
 */

public class InterestingLinkTargetImageLocalAccessCountUtilityFunction extends UtilityFunction {

/**
*This method searches the most accessed target image of a property of an image of InterestingLink and returns the division of 
*InterestingLinks propertys accessamount by number of accesses to the most accessed property which was searched. 
*@il This is the InterestingLink that is pruned in the method.
*@pl This is the Profile of the caller
*@returns an int that is a division of il's property accesscount by the amount of accesses to the most popular Property 
*/
    public int getUtility(InterestingLink il,UtilityInformation ui) {
	long maxImageAccessCount=0;
	ResourceCollection properties=ui.getSourceImage().getProperties();
	for (Iterator i=properties.iterator(); i.hasNext();) {
	    PropertyValue pv=((ResourceProperty)i.next()).getValue();
	    if (pv.isInstance()) {
		ResourceCollection images=((Instance)pv.getValue()).getImages();
		for (Iterator j=images.iterator(); j.hasNext();) {
		    Image it=(Image)j.next();
		    if (maxImageAccessCount<it.getWeight()) maxImageAccessCount=it.getWeight();

		}
		
	    }
	}

	int tmp=(int)(((il.getImage().getWeight()+1) << MAXUTILITYSHIFT)/(maxImageAccessCount+1));
	log(il,tmp);
	return tmp;
    }

}
