package fi.helsinki.w3m.filter;
import fi.helsinki.w3m.metadata.ontology.OntologyClass;

/*
 * $Author: jiemakel $
 * $Revision: 1.15 $
 * $Date: 2002/04/24 10:13:40 $
 */

/**
*This class encapsulates class OntologyClass of Metadata with it's 
*utility.
*
*/
public class InterestingOntologyClass extends OntologyClass implements Comparable {

    private int utility;
    
    public InterestingOntologyClass(OntologyClass oc){
	super(oc);
    }

    public int getUtility() {
	return utility;
    }
    
    public boolean setUtility(int util) {
	utility=util;
	return true;
    }

/**
*Calculates the utility of calling InterestingOntologyclass by a given 
*UtilityFunction and UtilityInformation.
*
*@param uf The UtilityFunction that is used.
*@param ui The UtilityInformation of the caller that is used.
*@returns The calculated utility
*/

        
    public int calculateUtility(UtilityFunction uf, UtilityInformation ui) {
	setUtility(uf.getUtility(this,ui));
	return getUtility();
    }

/**
*This method ompares a calling InterestingOntologyClass to a given object 
*that is casted to an InterestingObject. It return difference between the 
*utilities of the two.
*
*@param o The object that typecasted and compared
*@returns The difference mentioned above.
*/


    public int compareTo(Object o) {
	InterestingOntologyClass ioc=(InterestingOntologyClass)o;
	return getUtility()-ioc.getUtility();
    }
    
}
