package fi.helsinki.w3m.filter;
import fi.helsinki.w3m.profile.Profile;
import fi.helsinki.w3m.metadata.MuseumModel;
import fi.helsinki.w3m.metadata.ontology.OntologyClass;
import java.util.Collection;

/*
 * $Author: jiemakel $
 * $Revision: 1.12 $
 * $Date: 2002/05/08 09:01:12 $
 */

public class InterestingOntologyClassAccessCountUtilityFunction extends UtilityFunction{
    private MuseumModel model;
    
    public InterestingOntologyClassAccessCountUtilityFunction(MuseumModel model){
	this.model=model;
    }
/**
 *This method calculates the InterestingOntologyClass's accesscount divided by the accesscount of the most popular facet in 
*the model. 
*@param ioc The given InterestingOntologyClass
*@param profile This is the current Profile of the caller
*@returns an int that is mentioned above
*/
    public int getUtility(InterestingOntologyClass ioc, UtilityInformation ui){
	Collection facet = model.getPopularFacets(1);
	OntologyClass mpf=(OntologyClass)facet.iterator().next();
	int tmp = (int)(((ioc.getWeight()+1)<<MAXUTILITYSHIFT)/(mpf.getWeight()+1));
	log(ioc,tmp);
	return tmp;
    } 
}
