package fi.helsinki.w3m.filter;
import fi.helsinki.w3m.profile.Profile;
import fi.helsinki.w3m.metadata.*;
import java.util.Vector;

/*
 * $Author: jiemakel $
 * $Revision: 1.4 $
 * $Date: 2002/05/10 11:10:02 $
 */

/**
 *  An utilityfunction which penalizes images that have been previously viewed 
 */
public class PreviousImageUtilityFunction extends UtilityFunction {

    MuseumModel model;
    
    public PreviousImageUtilityFunction(MuseumModel model) {
	this.model=model;
    }

    public int getUtility(InterestingLink il, UtilityInformation ui) {
	int tmp=MAXUTILITY-1;
	Vector pi=ui.getProfile().getPreviousImages();
	int max = MAXUTILITY-1;
	if (pi.size()<max) max=pi.size();
	for (int i=0;i<max;i++) {
	    if (model.getImage((Id)pi.get(i)).equals(il.getImage())) {
		tmp=i;
		break;
	    }
	}
	log(il,tmp);
	return tmp;
    }
    
    public int getUtility(InterestingImage im, UtilityInformation ui) {
	int tmp=MAXUTILITY-1;
	Vector pi=ui.getProfile().getPreviousImages();
	int max = MAXUTILITY-1;
	if (pi.size()<max) max=pi.size();
	for (int i=0;i<max;i++) {
	    if (model.getImage((Id)pi.get(i)).equals(im)) {
		tmp=i;
		break;
	    }
	}
	log(im,tmp);
	return tmp;
    }

}
