package fi.helsinki.w3m.filter;
import fi.helsinki.w3m.profile.Profile;

/*
 * $Author: jiemakel $
 * $Revision: 1.8 $
 * $Date: 2002/05/08 09:01:12 $
 */

/**
*This class provides the random utility for a given InterestingLink, 
*InterestingOntologyClass or InterestingImage. It replaces the previous 
*RandomUtilityFunction.
*
*/
public class RandomThresholdUtilityFunction extends UtilityFunction {


/**
*This method calculates the utility of a given InterestingLink. It 
*calculates in ten percent of all method calls given InterestingLink as 
*"useless".  
*
*@param il This is the given InterestingLink, whose utility is to be 
*calculated.
*@param ui This is the UtilityInformation of the caller.
*@returns int This is the calculated utility
*/


  public int getUtility(InterestingLink il, UtilityInformation ui) {
      int tmp;
      if (Math.random()>0.999) tmp=0; else tmp=MAXUTILITY-1;
      log(il,tmp);
      return tmp;
  }

/**
*This method calculates the utility of a given InterestingOntologyClass. 
*It calculates in ten percent of all method calls 
*given InterestingOntologyClass as "useless" 
* 
* 
*@param ioc The InterestingOntologyClass that is received and whose utility is to be calculated.
*@param ui This is the UtilityInformation of the caller. 
*@returns int This is the calculated utility 
*/

  public int getUtility(InterestingOntologyClass ioc, UtilityInformation ui) {
      int tmp;
      if (Math.random()>0.999) tmp=0; else tmp=MAXUTILITY-1;
      log(ioc,tmp);
      return tmp;
  }

/**
*This method calculates the utility of a given InterestingImage. It 
*calculates in ten percent of all method calls given InterestingImage as 
"useless".
*
*@param ii This is the InterestingImage, whose utility is to be 
*calculated.
*@param ui This is the UtilityInformation of the caller.
*@returns int This is calculated utility.
*/

  public int getUtility(InterestingImage ii, UtilityInformation ui) {
      int tmp;
      if (Math.random()>0.999) tmp=0; else tmp=MAXUTILITY-1;
      log(ii,tmp);
      return tmp;
  }
}
