package fi.helsinki.w3m.filter;
import fi.helsinki.w3m.profile.Profile;
import fi.helsinki.w3m.metadata.ontology.OntologyResource;

/*
 * $Author: jiemakel $
 * $Revision: 1.18 $
 * $Date: 2002/05/10 11:27:34 $
 */

/**
 * A baseclass for all kinds of utility functions.
 */
public class UtilityFunction {

    public static final int MAXUTILITY=65536;
    public static final int MAXUTILITYSHIFT=16; // << 16 = * 65536

    public int getUtility(OntologyResource or, UtilityInformation ui) {
      log(or,MAXUTILITY);
      return MAXUTILITY;
    }

    public int getUtility(InterestingLink il, UtilityInformation ui) {
      log(il,MAXUTILITY);
      return MAXUTILITY;
    }

    public int getUtility(InterestingImage ii, UtilityInformation ui) {
      log(ii,MAXUTILITY);
      return MAXUTILITY;
    }

    public int getUtility(InterestingOntologyClass ioc, UtilityInformation ui) {
      log(ioc,MAXUTILITY);
      return MAXUTILITY;
    }

    public void log(Object o,int utility) {
	if (utility>MAXUTILITY || utility<0) {
	    System.out.println("!!Utility not between 0.0 and 1.0");
	    System.out.print(this.getClass().getName());
	    System.out.print(": getUtility(");
	    System.out.print(o.getClass().getName());
	    System.out.print(" [");
	    if (o.getClass().getName().equals("fi.helsinki.w3m.filter.InterestingLink")) 
		System.out.print(((InterestingLink)o).getLinkName()); 
	    else if (o.getClass().getName().equals("fi.helsinki.w3m.filter.InterestingOntologyClass")) 
		System.out.print(((InterestingOntologyClass)o).getLabel()); 
	    else if (o.getClass().getName().equals("fi.helsinki.w3m.filter.InterestingImage")) 
		System.out.print(((InterestingImage)o).getLabel()); 
	    System.out.print("]): ");
	    System.out.println((double)utility/MAXUTILITY);
	}
    }
}
