package fi.helsinki.w3m.metadata;

/*
 * $Revision: 1.7 $
 * $Date: 2002/05/17 12:31:19 $
 */

/**
*An implementation of Id for use where a single uri will be uniqe.
*/
public class SimpleId implements Id {
	/**
	*The actual id.
	*/
    protected String id;

	/**
	*A constructor for the class.
	*
	*@param uri An uri in String form to serve as the identifier for a ResourceCollection.
	*/
    public SimpleId(String uri) {
	this.id = uri;
    }

	/**
	*Returns the id as a String value.
	*
	*@return The id as a String value.
	*/
    public String getId() {
	return this.id;
    }

	/**
	*Returns the id as a String value.
	*
	*@return The id as a String value.
	*/
    public String getString() {
	return this.id;
    }

    public boolean equals(Object anotherId) {
	return this.compareTo(anotherId) == 0;
    }

	/**
	*Implements the Comparable interface.
	*/
    public int compareTo(Object anotherId) throws ClassCastException{
	return this.getId().compareTo(((SimpleId)anotherId).getId());
    }

	/**
	*Returns the id as a String value.
	*
	*@return The id as a String value.
	*/
    public String toString() { return id; }
}
