package fi.helsinki.w3m.metadata;

import fi.helsinki.w3m.metadata.ontology.*;

import java.util.Collection;

/*
 * $Revision: 1.5 $
 * $Date: 2002/05/17 12:31:19 $
 */

/**
 * This class provides a simple ResourceCollection of OntologyResource's.
 * The actual collection this class wraps can be anything of type
 * Collection.
 *
 * @author Samppa Saarela
 */
public class SimpleResourceCollection extends ResourceCollection {
    Collection resourceCollection;

    /**
     * Constructs a new SimpleResourceCollection that wraps
     * <tt>resourceCollection</tt>. 
     */
    public SimpleResourceCollection(Collection resourceCollection) {
	this.resourceCollection = resourceCollection;
    }

    /**
     * Adds <tt>o</tt> to this collection if <tt>resourceCollection</tt> supports
     * add operation. <tt>o</tt> should be of type OntologyResource.
     */
    public boolean add(Object o) throws ClassCastException,
					UnsupportedOperationException,
					NullPointerException,
					IllegalArgumentException {
	return this.resourceCollection.add(o);
    }

    /**
     * @see SimpleResourceIterator
     * @return Iterator (SimpleResourceIterator) for this collection.
     */
    protected ResourceIterator getIterator() {
	if (this.resourceCollection != null) {
	    return new SimpleResourceIterator(this.resourceCollection.iterator());
	}
	else {
	    return new SimpleResourceIterator();
	}
    }
}
