package fi.helsinki.w3m.metadata;

import fi.helsinki.w3m.metadata.ontology.*;
import fi.helsinki.w3m.metadata.item.*;

import java.util.*;

/*
 * $Revision: 1.3 $
 * $Date: 2002/05/17 12:31:19 $
 */

/**
 * This class provides a ResourceIterator for a Collection of
 * OntologyResources. In practice this class simply wraps
 * an Iterator provided in constructor.
 */
public class SimpleResourceIterator extends ResourceIterator{

    /**
     * The actual iterator this wraps.
     */
    private Iterator iterator;

    /**
     * Creates an empty iterator. 
     */
    public SimpleResourceIterator() {}

    /**
     * Constructs SimpleResourceIterator that wraps <tt>iterator</tt>.
     */
    public SimpleResourceIterator(Iterator iterator) {
	this.iterator = iterator;
    }

    /**
     * Does nothing. 
     */
    protected void closeHead() {}

    /**
     * @return <tt>this.iterator.hasNext()</tt>.
     */
    protected boolean hasNextHead() {
 	boolean hasNextHead = false;
	if (this.iterator != null) {
	    hasNextHead = this.iterator.hasNext();
	}
	return hasNextHead;
    }

    /**
     * @return <tt>this.iterator.next()</tt>.
     */
    protected Object getNext() {
	Object nextObject = null;
	if (this.iterator != null && this.iterator.hasNext()) {
	    nextObject = this.iterator.next();
	}
	return nextObject;
    }
}
