package fi.helsinki.w3m.metadata;

import java.util.*;
import java.net.*;

import com.hp.hpl.mesa.rdf.jena.model.* ;
import com.hp.hpl.mesa.rdf.jena.common.* ;
import com.hp.hpl.jena.util.* ;

import fi.helsinki.w3m.metadata.ontology.*;
import fi.helsinki.w3m.metadata.item.*;

/*
 * $Revision: 1.11 $
 * $Date: 2002/05/17 12:31:19 $
 */

/**
 *A ResourceCollection for statements.
 *
 *@author Samppa Saarela
 */
public class StatementResourceCollection extends ResourceCollection {

    /**
     * Jena's Model.
     */
    protected Model model;

    protected ResourceProvider resourceProvider;
    protected Selector selector;

    public StatementResourceCollection() {}

    /**
     *A constructor for this class.
     */
    public StatementResourceCollection(Model model, Selector selector, ResourceProvider resourceProvider) {
	this.model = model;
	this.resourceProvider = resourceProvider;
	this.selector = selector; 
    }
    
    /**
     *Returns a ResourceIterator to the statements in this ResouceCollection.
	 *
	 *@return A ResourceIterator to the statements in this ResouceCollection.
     */
    protected ResourceIterator getIterator() {
	StatementResourceIterator iterator = null;
	if (this.model != null && this.selector != null && this.resourceProvider != null) {
	    try {
		iterator = new StatementResourceIterator(model.listStatements(this.selector), resourceProvider);
	    } catch (Exception e) {
		e.printStackTrace();
	    }
	}
	return iterator;
    }
}
