package fi.helsinki.w3m.metadata;

import java.util.*;
import java.net.*;

import com.hp.hpl.mesa.rdf.jena.model.* ;
import com.hp.hpl.mesa.rdf.jena.common.* ;
import com.hp.hpl.jena.util.* ;

import fi.helsinki.w3m.metadata.ontology.*;
import fi.helsinki.w3m.metadata.item.*;

/*
 * $Revision: 1.15 $
 * $Date: 2002/05/17 12:31:19 $
 */
 
public class StatementResourceIterator extends ResourceIterator{
    private StmtIterator iterator;

    public StatementResourceIterator() {}
    public StatementResourceIterator(StmtIterator iterator, ResourceProvider resourceProvider) {
	super(resourceProvider);
	this.iterator = iterator;
    }

    protected void closeHead() throws RDFException {
	// Close this iterator
	if (iterator != null) {
	    iterator.close();
	}
    }

    protected boolean hasNextHead() throws RDFException {
	boolean hasNextHead = false;
	if (this.iterator != null) {
	    hasNextHead = this.iterator.hasNext();
	}
	return hasNextHead;
    }

    protected Object getNext() throws RDFException {
	Object nextObject = null;
	if (this.iterator != null && this.iterator.hasNext()) {
	    nextObject = this.iterator.next();
	}
	return nextObject;
    }
}
