package fi.helsinki.w3m.metadata.ontology;

import java.util.*;
import java.net.*;

import fi.helsinki.w3m.metadata.*;
import fi.helsinki.w3m.metadata.item.*;

/*
 * $Revision: 1.12 $
 * $Date: 2002/05/17 12:31:23 $
 */

/**
*Defines a property in a specific domain.
*/
public class PropertyDefinition extends OntologyClass {
    protected OntologyClass domain;
    protected OntologyClass range;

	/**
	*A constructor for the class.
	*
	*@param model The MuseumModel this PropertyDefinition belongs to.	
	*@param id The id of this PropertyDefinition.
	*/
    public PropertyDefinition(MuseumModel model, Id id) {
	super(model, id);
    }

	/**
	*A constructor for the class with range and domain. Not in use.
	*
	*@param model The MuseumModel this PropertyDefinition belongs to.	
	*@param range The range for this PropertyDefinition.
	*@param domain The domain for this PropertyDefinition.
	*@param id The id of this PropertyDefinition.	
	*/
    public PropertyDefinition(MuseumModel model, OntologyClass range, OntologyClass domain, Id id) {
	super(model, id);
	this.domain = domain;
	this.range = range;
    }

	/**
	*Returns the domain for this PropertyDefinition. Not in use.
	*
	*@return An OntologyClass-object representing the domain for this PropertyDefinition.
	*/
    public OntologyClass getDomain() {
	return this.domain;
    }

	/**
	*Returns the range for this PropertyDefinition. Not in use.
	*
	*@return An OntologyClass-object representing the range for this PropertyDefinition.
	*/
    public OntologyClass getRange() {
	return this.range; 
    }
}
