package fi.helsinki.w3m.ui.tags;

import java.util.Vector;
import java.util.Iterator;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.BodyTagSupport;

import fi.helsinki.w3m.beans.*;
import fi.helsinki.w3m.profile.Profile;

public class AddableFacetIteratorTag extends BodyTagSupport {
	private Profile profile;
	private Vector collection;
	private Iterator iterator;


	public int doStartTag() throws JspException {
		initProfile();
		collection = profile.getAddableFacetBeans();
		//System.out.println("got Vector from getFacetBeans():"+collection);
		iterator = collection.iterator();
		if(iterator.hasNext()){
			AddableFacetBean afb = (AddableFacetBean)iterator.next();
			pageContext.setAttribute("addabeFacet", afb );
			pageContext.setAttribute("facetId", afb.getId() );
			pageContext.setAttribute("facetName", afb.getName() );
			pageContext.setAttribute("facetImageCount", ""+afb.getImageCount() );
			return EVAL_BODY_TAG;
		}
		return SKIP_BODY;
	}

	public int doAfterBody() throws JspException {
		//System.out.println("doAfterBody()");
		if(iterator.hasNext()){
			AddableFacetBean afb = (AddableFacetBean)iterator.next();
			
			pageContext.setAttribute("facetId", afb.getId() );
			pageContext.setAttribute("facetName", afb.getName() );
			pageContext.setAttribute("facetImageCount", ""+afb.getImageCount() );
			
			pageContext.setAttribute("addabeFacet", afb );
			return EVAL_BODY_TAG;
		}else{
			try{
				//System.out.println("add else");
				getBodyContent().writeOut(getPreviousOut());
				//System.out.println("add else... after print");
			}catch(Exception e){
				e.printStackTrace();
				throw new JspException(e.getMessage());
			}
			//System.out.println("add else.. skip_body");
			return SKIP_BODY;
		}
	}

	
    private void initProfile(){
	Profile p = (Profile)pageContext.getSession().getAttribute("profile");
	if(p == null){
	    this.profile = new Profile();
	    pageContext.getSession().setAttribute("profile", p);
	}else{
	    this.profile = p;
	}
    }	
}
