package fi.helsinki.w3m.ui.tags;

import java.util.Vector;
import java.util.Iterator;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.BodyTagSupport;

import fi.helsinki.w3m.beans.*;

public class ClassIteratorTag extends BodyTagSupport {
	private Iterator iterator;
	private Vector collection;
	private boolean isImage = false;


	public void setFacet(String facet){
		//System.out.println("nodes: "+((FacetBean)pageContext.getAttribute("facet")));
		collection = ((FacetBean)pageContext.getAttribute("facet")).getVisibleNodes();
		//System.out.println("got Vector from getVisibleNodes():"+collection);
		iterator = collection.iterator();
		if(iterator.hasNext()){
			NodeBean nb = (NodeBean)iterator.next();
			if(nb instanceof ClassNodeBean){
				pageContext.setAttribute("isImage", "false" );
				//System.out.println("setting Class: "+nb);
				pageContext.setAttribute("classNode", nb );
			}else{
				pageContext.setAttribute("isImage", "true" );
				//System.out.println("setting image: "+nb);
				pageContext.setAttribute("imageNode", nb );
			}
		}
	}

	public int doStartTag() throws JspException {
		//System.out.println("doStartTag() with collection: "+collection);
		return collection.size() > 0 ? EVAL_BODY_TAG :SKIP_BODY;
	}

	public int doAfterBody() throws JspException {
		//System.out.println("doAfterBody()");
		if(iterator.hasNext()){
			NodeBean nb = (NodeBean)iterator.next();
			if(nb instanceof ClassNodeBean){
				pageContext.setAttribute("isImage", "false" );
				//System.out.println("setting Class: "+nb);
				pageContext.setAttribute("classNode", nb );
			}else{
				pageContext.setAttribute("isImage", "true" );
				//System.out.println("setting image: "+nb);
				pageContext.setAttribute("imageNode", nb );
			}
			return EVAL_BODY_TAG;
		}else{
			//System.out.println("ELSE!!");
			try{
				getBodyContent().writeOut(getPreviousOut());
			}catch(Exception e){
				e.printStackTrace();
				throw new JspException(e.getMessage());
			}
			
			return SKIP_BODY;
		}
	}

}
