package fi.helsinki.w3m.ui.tags;

import fi.helsinki.w3m.metadata.item.*;
import fi.helsinki.w3m.metadata.MuseumModel;
import fi.helsinki.w3m.metadata.*;

import fi.helsinki.w3m.profile.*;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;

import java.util.*;


public class ImageInfoTag extends TagSupport {

    MuseumModel model;
	
    Profile profile;
	
    public int doStartTag() {
	initProfile();
	try{
			
	    String location = "/home/tkt_w3mu/wwwmuseo_group/wwwmuseo_webapp/WEB-INF/data/";
	    model = fi.helsinki.w3m.W3m.getModel(location);
		
	    Image image = null;
		
	    image = model.getImage(new SimpleId(pageContext.getRequest().getParameter("class")));
		
	    pageContext.setAttribute("imageDescription",  image.getDescription());
		
	    ImageFile imf = image.getImageFile(ImageFile.ORIGINAL);

	    // SCALING

	    // original image size
	    int width = imf.getWidth();
	    int height = imf.getHeight();
	    //System.out.println("original width="+width+", original height="+height);

	    // max size
	    int maxWidth = profile.getMaxImageWidth();
	    int maxHeight = profile.getMaxImageHeight();
	    
	    int wdif = maxWidth - width;
	    int hdif = maxHeight - height;
	    
	    // scaling needed?
	    if (wdif < 0 || hdif < 0) {
		double sfactor = 1.0;
		// scale by width
		if (wdif < hdif) {
		    sfactor = ((double)maxWidth) / width;
		    width = maxWidth;
		    height = (int)Math.round(sfactor * height);
		}
		// scale by height
		else {
		    sfactor = ((double)maxHeight) / height;
		    height = maxHeight;
		    width = (int)Math.round(sfactor * width);
		}
	    }
		
	    pageContext.setAttribute("imageHeight", ""+height);
	    pageContext.setAttribute("imageWidth",  ""+width);
	    pageContext.setAttribute("imageURL",  imf.getURL());

	    // Thumbnail
// 	    imf = image.getImageFile(ImageFile.THUMBNAIL);
	    pageContext.setAttribute("imageThumbURL", imf.getURL());
		
	}catch(Exception e){
	    e.printStackTrace();
	}
	return EVAL_BODY_INCLUDE;
    }
	
    private void initProfile(){
	Profile p = (Profile)pageContext.getSession().getAttribute("profile");
	if(p == null){
	    this.profile = new Profile();
	    pageContext.getSession().setAttribute("profile", p);
	}else{
	    this.profile = p;
	}
    }	
	
}
