package fi.helsinki.w3m.ui.tags;

import java.util.*;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.BodyTagSupport;

import fi.helsinki.w3m.metadata.*;
import fi.helsinki.w3m.profile.*;
import fi.helsinki.w3m.filter.*;
import fi.helsinki.w3m.metadata.item.*;


public class ImageInterestingLinksIteratorTag extends BodyTagSupport {

	Iterator iterator;
	Filter filter;
	Profile profile;

	public int doStartTag() throws JspException {
		initProfile();
		
		String location = "/home/tkt_w3mu/wwwmuseo_group/wwwmuseo_webapp/WEB-INF/data/";
		filter = fi.helsinki.w3m.W3m.getFilter(location);
		
		iterator = filter.getInterestingLinks(new SimpleId(pageContext.getRequest().getParameter("class")),profile, 6).iterator();
		if(iterator.hasNext()){
			InterestingLink il = (InterestingLink)iterator.next();
			
			pageContext.setAttribute("thumbURL", ""+il.getImage().getImageFile(ImageFile.THUMBNAIL).getURL());
			
			pageContext.setAttribute("linkName",  il.getLinkName());
			pageContext.setAttribute("linkImageId",  il.getImage().getId().getString());
			pageContext.setAttribute("linkUtility",  ""+((double)il.getUtility()/UtilityFunction.MAXUTILITY));
			
			int numberOfStars = 0;
			
			for(int i = il.getUtility(); i > 0 && numberOfStars < 5; i = i - 10000){
				++numberOfStars;
			}
			
			
			String starsHTML = "";
			for(int i = 0; i < numberOfStars; ++i){
				starsHTML = starsHTML + "<img src=\"http://www.cs.helsinki.fi/group/wwwmuseo/images/star.gif\">";
			}
			
			pageContext.setAttribute("starsHTML",  starsHTML);			
			
			return EVAL_BODY_TAG;
		}else{
			return SKIP_BODY;
		}
	}

	public int doAfterBody() throws JspException {
		if(iterator.hasNext()){
			InterestingLink il = (InterestingLink)iterator.next();
			
			pageContext.setAttribute("thumbURL", ""+il.getImage().getImageFile(ImageFile.THUMBNAIL).getURL());
			
			pageContext.setAttribute("linkName",  il.getLinkName());
			pageContext.setAttribute("linkImageId",  il.getImage().getId().getString());
			pageContext.setAttribute("linkUtility",  ""+((double)il.getUtility()/UtilityFunction.MAXUTILITY));
			
			int numberOfStars = 0;
			
			for(int i = il.getUtility(); i > 0 && numberOfStars < 5; i = i - 10000){
				++numberOfStars;
			}
			
			String starsHTML = "";
			for(int i = 0; i < numberOfStars; ++i){
				starsHTML = starsHTML + "<img src=\"http://www.cs.helsinki.fi/group/wwwmuseo/images/star.gif\">";
			}
			
			pageContext.setAttribute("starsHTML",  starsHTML);
			
			return EVAL_BODY_TAG;
		}else{
			try{
				getBodyContent().writeOut(getPreviousOut());
			}catch(Exception e){
				throw new JspException(e.getMessage());
			}
			
			return SKIP_BODY;
		}
	}

	private void initProfile(){
		Profile p = (Profile)pageContext.getSession().getAttribute("profile");
		if(p == null){
			this.profile = new Profile();
			pageContext.getSession().setAttribute("profile", p);
		}else{
			this.profile = p;
		}
	}
	

}
