package fi.helsinki.w3m.ui.tags;

import java.util.Vector;
import java.util.Iterator;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.BodyTagSupport;

import fi.helsinki.w3m.profile.Profile;
import fi.helsinki.w3m.beans.*;

public class IteratorTag extends BodyTagSupport {
	private Iterator iterator;
	private Vector collection;
	private Profile profile;


	public void setProfile(String foo){
		//System.out.println("setProfile()");
		initProfile();
		collection = profile.getFacetBeans();
		//System.out.println("got Vector from getFacetBeans():"+collection);
		iterator = collection.iterator();
		if(iterator.hasNext()){
			FacetBean fb = (FacetBean)iterator.next();
			//System.out.println("setting test: "+fb);
			//System.out.println("facetId: "+fb.getFacetId());
			pageContext.setAttribute("facet", fb );
		}
	}

	public int doStartTag() throws JspException {
		//System.out.println("doStartTag() with collection: "+collection);
		return collection.size() > 0 ? EVAL_BODY_TAG :SKIP_BODY;
	}

	public int doAfterBody() throws JspException {
		//System.out.println("doAfterBody()");
		if(iterator.hasNext()){
			FacetBean fb = (FacetBean)iterator.next();
			
			//System.out.println("setting test: "+fb);
			//System.out.println("facetId: "+fb.getFacetId());
			pageContext.setAttribute("facet", fb );
			return EVAL_BODY_TAG;
		}else{
			try{
				getBodyContent().writeOut(getPreviousOut());
			}catch(Exception e){
				throw new JspException(e.getMessage());
			}
			
			return SKIP_BODY;
		}
	}


    private void initProfile(){
	Profile p = (Profile)pageContext.getSession().getAttribute("profile");
	if(p == null){
	    this.profile = new Profile();
	    pageContext.getSession().setAttribute("profile", p);
	}else{
	    this.profile = p;
	}
    }

}
